---
title: this
slug: Web/JavaScript/Reference/Operators/this
tags:
  - JavaScript
  - Language feature
  - Operator
  - Primary Expressions
  - Reference
  - this
---
<div>{{jsSidebar("Operators")}}</div>

<p>A <strong>function's <code>this</code> keyword</strong> behaves a little differently in JavaScript compared to other languages. It also has some differences between <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a> and non-strict mode.</p>

<p>In most cases, the value of <code>this</code> is determined by how a function is called (runtime binding). It can't be set by assignment during execution, and it may be different each time the function is called. ES5 introduced the {{jsxref("Function.prototype.bind()", "bind()")}} method to {{jsxref('Operators/this', "set the value of a function's <code>this</code> regardless of how it's called", 'The_bind_method', 1)}}, and ES2015 introduced <a href="../Functions/Arrow_functions">arrow functions</a> which don't provide their own <code>this</code> binding (it retains the <code>this</code> value of the enclosing lexical context).</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-this.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">this</pre>

<h3 id="Value">Value</h3>

<p>A property of an execution context (global, function or eval) that, in non–strict mode, is always a reference to an object and in strict mode can be any value.</p>

<h2 id="Description">Description</h2>

<h3 id="Global_context">Global context</h3>

<p>In the global execution context (outside of any function), <code>this</code> refers to the global object whether in strict mode or not.</p>

<pre class="brush:js">// In web browsers, the window object is also the global object:
console.log(this === window); // true

a = 37;
console.log(window.a); // 37

this.b = "MDN";
console.log(window.b)  // "MDN"
console.log(b)         // "MDN"
</pre>

<div class="notecard note">
<p><strong>Note:</strong> You can always easily get the global object using the global {{jsxref("globalThis")}} property, regardless of the current context in which your code is running.</p>
</div>

<h3 id="Function_context">Function context</h3>

<p>Inside a function, the value of <code>this</code> depends on how the function is called.</p>

<p>Since the following code is not in <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a>, and because the value of <code>this</code> is not set by the call, <code>this</code> will default to the global object, which is {{domxref("Window", "window")}} in a browser.</p>

<pre class="brush:js">function f1() {
  return this;
}

// In a browser:
f1() === window; // true

// In Node:
f1() === globalThis; // true</pre>

<p>In strict mode, however, if the value of <code>this</code> is not set when entering an execution context, it remains as <code>undefined</code>, as shown in the following example:</p>

<pre class="brush:js">function f2() {
  'use strict'; // see strict mode
  return this;
}

f2() === undefined; // true
</pre>

<div class="note">In the second example, <code>this</code> should be {{jsxref("undefined")}}, because <code>f2</code> was called directly and not as a method or property of an object (e.g. <code>window.f2()</code>). This feature wasn't implemented in some browsers when they first started to support <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a>. As a result, they incorrectly returned the <code>window</code> object.</div>

<p>To set the value of <code>this</code> to a particular value when calling a function, use {{jsxref("Function.prototype.call()", "call()")}}, or {{jsxref("Function.prototype.apply()", "apply()")}} as in the examples below.</p>

<h3 id="Class_context">Class context</h3>

<p>The behavior of <code>this</code> in <a href="/en-US/docs/Web/JavaScript/Reference/Classes">classes</a> and functions is similar, since classes are functions under the hood. But there are some differences and caveats.</p>

<p>Within a class constructor, <code>this</code> is a regular object. All non-static methods within the class are added to the prototype of <code>this</code>:</p>

<pre class="brush: js">class Example {
  constructor() {
    const proto = Object.getPrototypeOf(this);
    console.log(Object.getOwnPropertyNames(proto));
  }
  first(){}
  second(){}
  static third(){}
}

new Example(); // ['constructor', 'first', 'second']
</pre>

<div class="notecard note">
<p><strong>Note:</strong> Static methods are not properties of <code>this</code>. They are properties of the class itself.</p>
</div>

<h3 id="Derived_classes">Derived classes</h3>

<p>Unlike base class constructors, derived constructors have no initial <code>this</code> binding. Calling  {{jsxref("Operators/super", "super()")}} creates a <code>this</code> binding within the constructor and essentially has the effect of evaluating the following line of code, where Base is the inherited class:</p>

<pre class="brush: js">this = new Base();</pre>

<div class="notecard warning">
<p><strong>Warning:</strong> Referring to <code>this</code> before calling <code>super()</code> will throw an error.</p>
</div>

<p>Derived classes must not return before calling <code>super()</code>, unless they return an <code>Object</code> or have no constructor at all.</p>

<pre class="brush: js">class Base {}
class Good extends Base {}
class AlsoGood extends Base {
  constructor() {
    return {a: 5};
  }
}
class Bad extends Base {
  constructor() {}
}

new Good();
new AlsoGood();
new Bad(); // ReferenceError</pre>

<h2 id="Examples">Examples</h2>

<h3 id="this_in_function_contexts">this in function contexts</h3>

<pre class="brush:js">// An object can be passed as the first argument to call or apply and this will be bound to it.
var obj = {a: 'Custom'};

// We declare a variable and the variable is assigned to the global window as its property.
var a = 'Global';

function whatsThis() {
  return this.a;  // The value of this is dependent on how the function is called
}

whatsThis();          // 'Global' as this in the function isn't set, so it defaults to the global/window object
whatsThis.call(obj);  // 'Custom' as this in the function is set to obj
whatsThis.apply(obj); // 'Custom' as this in the function is set to obj
</pre>

<h3 id="this_and_object_conversion">this and object conversion</h3>

<pre class="brush:js">function add(c, d) {
  return this.a + this.b + c + d;
}

var o = {a: 1, b: 3};

// The first parameter is the object to use as
// 'this', subsequent parameters are passed as
// arguments in the function call
add.call(o, 5, 7); // 16

// The first parameter is the object to use as
// 'this', the second is an array whose
// members are used as the arguments in the function call
add.apply(o, [10, 20]); // 34
</pre>

<p>Note that in non–strict mode, with <code>call</code> and <code>apply</code>, if the value passed as <code>this</code> is not an object, an attempt will be made to convert it to an object. Values <code>null</code> and <code>undefined</code> become the global object. Primitives like <code>7</code> or <code>'foo'</code> will be converted to an Object using the related constructor, so the primitive number <code>7</code> is converted to an object as if by <code>new Number(7)</code> and the string <code>'foo'</code> to an object as if by <code>new String('foo')</code>, e.g.</p>

<pre class="brush:js">function bar() {
  console.log(Object.prototype.toString.call(this));
}

bar.call(7);     // [object Number]
bar.call('foo'); // [object String]
bar.call(undefined); // [object global]
</pre>

<h3 id="The_bind_method">The <code>bind</code> method</h3>

<p>ECMAScript 5 introduced {{jsxref("Function.prototype.bind()")}}. Calling <code>f.bind(someObject)</code> creates a new function with the same body and scope as <code>f</code>, but where <code>this</code> occurs in the original function, in the new function it is permanently bound to the first argument of <code>bind</code>, regardless of how the function is being used.</p>

<pre class="brush:js">function f() {
  return this.a;
}

var g = f.bind({a: 'azerty'});
console.log(g()); // azerty

var h = g.bind({a: 'yoo'}); // bind only works once!
console.log(h()); // azerty

var o = {a: 37, f: f, g: g, h: h};
console.log(o.a, o.f(), o.g(), o.h()); // 37,37, azerty, azerty
</pre>

<h3 id="Arrow_functions">Arrow functions</h3>

<p>In <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions">arrow functions</a>, <code>this</code> retains the value of the enclosing lexical context's <code>this</code>. In global code, it will be set to the global object:</p>

<pre class="brush: js">var globalObject = this;
var foo = (() =&gt; this);
console.log(foo() === globalObject); // true</pre>

<div class="note">
<p>Note: if <code>this</code> arg is passed to <code>call</code>, <code>bind</code>, or <code>apply</code> on invocation of an arrow function it will be ignored. You can still prepend arguments to the call, but the first argument (<code>thisArg</code>) should be set to <code>null</code>.</p>
</div>

<pre class="brush: js">// Call as a method of an object
var obj = {func: foo};
console.log(obj.func() === globalObject); // true

// Attempt to set this using call
console.log(foo.call(obj) === globalObject); // true

// Attempt to set this using bind
foo = foo.bind(obj);
console.log(foo() === globalObject); // true</pre>

<p>No matter what, <code>foo</code>'s <code>this</code> is set to what it was when it was created (in the example above, the global object). The same applies to arrow functions created inside other functions: their <code>this</code> remains that of the enclosing lexical context.</p>

<pre class="brush: js">// Create obj with a method bar that returns a function that
// returns its this. The returned function is created as
// an arrow function, so its this is permanently bound to the
// this of its enclosing function. The value of bar can be set
// in the call, which in turn sets the value of the
// returned function.
var obj = {
  bar: function() {
    var x = (() =&gt; this);
    return x;
  }
};

// Call bar as a method of obj, setting its this to obj
// Assign a reference to the returned function to fn
var fn = obj.bar();

// Call fn without setting this, would normally default
// to the global object or undefined in strict mode
console.log(fn() === obj); // true

// But caution if you reference the method of obj without calling it
var fn2 = obj.bar;
// Calling the arrow function's this from inside the bar method()
// will now return window, because it follows the this from fn2.
console.log(fn2()() == window); // true
</pre>

<p>In the above, the function (call it anonymous function A) assigned to <code>obj.bar</code> returns another function (call it anonymous function B) that is created as an arrow function. As a result, function B's <code>this</code> is permanently set to the <code>this</code> of <code>obj.bar</code> (function A) when called. When the returned function (function B) is called, its <code>this</code> will always be what it was set to initially. In the above code example, function B's <code>this</code> is set to function A's <code>this</code> which is <code>obj</code>, so it remains set to <code>obj</code> even when called in a manner that would normally set its <code>this</code> to <code>undefined</code> or the global object (or any other method as in the previous example in the global execution context).</p>

<h3 id="As_an_object_method">As an object method</h3>

<p>When a function is called as a method of an object, its <code>this</code> is set to the object the method is called on.</p>

<p>In the following example, when <code>o.f()</code> is invoked, inside the function <code>this</code> is bound to the <code>o</code> object.</p>

<pre class="brush:js">var o = {
  prop: 37,
  f: function() {
    return this.prop;
  }
};

console.log(o.f()); // 37
</pre>

<p>Note that this behavior is not at all affected by how or where the function was defined. In the previous example, we defined the function inline as the <code>f</code> member during the definition of <code>o</code>. However, we could have just as easily defined the function first and later attached it to <code>o.f</code>. Doing so results in the same behavior:</p>

<pre class="brush:js">var o = {prop: 37};

function independent() {
  return this.prop;
}

o.f = independent;

console.log(o.f()); // 37
</pre>

<p>This demonstrates that it matters only that the function was invoked from the <code>f</code> member of <code>o</code>.</p>

<p>Similarly, the <code>this</code> binding is only affected by the most immediate member reference. In the following example, when we invoke the function, we call it as a method <code>g</code> of the object <code>o.b</code>. This time during execution, <code>this</code> inside the function will refer to <code>o.b</code>. The fact that the object is itself a member of <code>o</code> has no consequence; the most immediate reference is all that matters.</p>

<pre class="brush:js">o.b = {g: independent, prop: 42};
console.log(o.b.g()); // 42
</pre>

<h4 id="this_on_the_objects_prototype_chain"><code>this</code> on the object's prototype chain</h4>

<p>The same notion holds true for methods defined somewhere on the object's prototype chain. If the method is on an object's prototype chain, <code>this</code> refers to the object the method was called on, as if the method were on the object.</p>

<pre class="brush:js">var o = {f: function() { return this.a + this.b; }};
var p = Object.create(o);
p.a = 1;
p.b = 4;

console.log(p.f()); // 5
</pre>

<p>In this example, the object assigned to the variable <code>p</code> doesn't have its own <code>f</code> property, it inherits it from its prototype. But it doesn't matter that the lookup for <code>f</code> eventually finds a member with that name on <code>o</code>; the lookup began as a reference to <code>p.f</code>, so <code>this</code> inside the function takes the value of the object referred to as <code>p</code>. That is, since <code>f</code> is called as a method of <code>p</code>, its <code>this</code> refers to <code>p</code>. This is an interesting feature of JavaScript's prototype inheritance.</p>

<h4 id="this_with_a_getter_or_setter"><code>this</code> with a getter or setter</h4>

<p>Again, the same notion holds true when a function is invoked from a getter or a setter. A function used as getter or setter has its <code>this</code> bound to the object from which the property is being set or gotten.</p>

<pre class="brush:js">function sum() {
  return this.a + this.b + this.c;
}

var o = {
  a: 1,
  b: 2,
  c: 3,
  get average() {
    return (this.a + this.b + this.c) / 3;
  }
};

Object.defineProperty(o, 'sum', {
    get: sum, enumerable: true, configurable: true});

console.log(o.average, o.sum); // 2, 6
</pre>

<h3 id="As_a_constructor">As a constructor</h3>

<p>When a function is used as a constructor (with the {{jsxref("Operators/new", "new")}} keyword), its <code>this</code> is bound to the new object being constructed.</p>

<div class="note">
<p>While the default for a constructor is to return the object referenced by <code>this</code>, it can instead return some other object (if the return value isn't an object, then the <code>this</code> object is returned).</p>
</div>

<pre class="brush:js">/*
 * Constructors work like this:
 *
 * function MyConstructor(){
 *   // Actual function body code goes here.
 *   // Create properties on |this| as
 *   // desired by assigning to them.  E.g.,
 *   this.fum = "nom";
 *   // et cetera...
 *
 *   // If the function has a return statement that
 *   // returns an object, that object will be the
 *   // result of the |new| expression.  Otherwise,
 *   // the result of the expression is the object
 *   // currently bound to |this|
 *   // (i.e., the common case most usually seen).
 * }
 */

function C() {
  this.a = 37;
}

var o = new C();
console.log(o.a); // 37

function C2() {
  this.a = 37;
  return {a: 38};
}

o = new C2();
console.log(o.a); // 38
</pre>

<p>In the last example (<code>C2</code>), because an object was returned during construction, the new object that <code>this</code> was bound to gets discarded. (This essentially makes the statement "<code>this.a = 37;</code>" dead code. It's not exactly dead because it gets executed, but it can be eliminated with no outside effects.)</p>

<h3 id="As_a_DOM_event_handler">As a DOM event handler</h3>

<p>When a function is used as an event handler, its <code>this</code> is set to the element on which the listener is placed (some browsers do not follow this convention for listeners added dynamically with methods other than {{domxref("EventTarget/addEventListener", "addEventListener()")}}).</p>

<pre class="brush:js">// When called as a listener, turns the related element blue
function bluify(e) {
  // Always true
  console.log(this === e.currentTarget);
  // true when currentTarget and target are the same object
  console.log(this === e.target);
  this.style.backgroundColor = '#A5D9F3';
}

// Get a list of every element in the document
var elements = document.getElementsByTagName('*');

// Add bluify as a click listener so when the
// element is clicked on, it turns blue
for (var i = 0; i &lt; elements.length; i++) {
  elements[i].addEventListener('click', bluify, false);
}</pre>

<h3 id="In_an_inline_event_handler">In an inline event handler</h3>

<p>When the code is called from an inline <a href="/en-US/docs/Web/Guide/Events/Event_handlers">on-event handler</a>, its <code>this</code> is set to the DOM element on which the listener is placed:</p>

<pre class="brush:js">&lt;button onclick="alert(this.tagName.toLowerCase());"&gt;
  Show this
&lt;/button&gt;
</pre>

<p>The above alert shows <code>button</code>. Note however that only the outer code has its <code>this</code> set this way:</p>

<pre class="brush:js">&lt;button onclick="alert((function() { return this; })());"&gt;
  Show inner this
&lt;/button&gt;
</pre>

<p>In this case, the inner function's <code>this</code> isn't set so it returns the global/window object (i.e. the default object in non–strict mode where <code>this</code> isn't set by the call).</p>

<h3 id="this_in_classes">this in classes</h3>

<div class="notecard note"></div>

<p>Just like with regular functions, the value of <code>this</code> within methods depends on how they are called. Sometimes it is useful to override this behavior so that <code>this</code> within classes always refers to the class instance. To achieve this, bind the class methods in the constructor:</p>

<pre class="brush: js">class Car {
  constructor() {
    // Bind sayBye but not sayHi to show the difference
    this.sayBye = this.sayBye.bind(this);
  }
  sayHi() {
    console.log(`Hello from ${this.name}`);
  }
  sayBye() {
    console.log(`Bye from ${this.name}`);
  }
  get name() {
    return 'Ferrari';
  }
}

class Bird {
  get name() {
    return 'Tweety';
  }
}

const car = new Car();
const bird = new Bird();

// The value of 'this' in methods depends on their caller
car.sayHi(); // Hello from Ferrari
bird.sayHi = car.sayHi;
bird.sayHi(); // Hello from Tweety

// For bound methods, 'this' doesn't depend on the caller
bird.sayBye = car.sayBye;
bird.sayBye();  // Bye from Ferrari</pre>

<div class="notecard note">
<p><strong>Note:</strong> Classes are always strict mode code. Calling methods with an undefined <code>this</code> will throw an error.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-this-keyword', 'The this keyword')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.this")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">Strict mode</a></li>
 <li><a href="https://dmitripavlutin.com/gentle-explanation-of-this-in-javascript/">Gentle explanation of 'this' keyword in JavaScript</a></li>
 <li>Getting the global context: {{jsxref("globalThis")}}</li>
</ul>
